// Copyright 2000-2002 Macromedia, Inc. All rights reserved.

//*************************API**************************

function commandButtons(){
  return new Array(MM.BTN_OK,     "okClicked()",
                   MM.BTN_Cancel,"cancelClicked()",
                   MM.BTN_Help,"displayHelp()" );
}

//Global Vars
var helpDoc     = MM.HELP_cmdSelectDSNList;
var tagList     = new Array();
var selectObj;

// --- TEMPORARY SOLUTION -----
//We're using a hard-coded URL. This will be replaced by a method that will point to this file on the fly.
var remPath     = "http://ultraqa5.macromedia.com/udwebtech/patterns/aspx/Introspection/final/Introspect.aspx";
//-----------------------------

var libPath     = "/TagLibraries/TagLibraries.vtm"
var tagLibOpenPattern  = "<TAGLIBRARY NAME=\"@@NAME@@\" FILETYPES=\"*.aspx\" PREFIX=\"<@@NAME@@:\">"
var tagRefPattern      = "<TAGREF NAME=\"@@NAME@@\" FILE=\"ASP.NET/@@NAME@@.vtm\"/>"
var tagLibClosePattern = "</TAGLIBRARY>"
var tagPattern  = "<TAG NAME=\"@@NAME@@\" @@BIND@@>\r\n</TAG>"
var libFileName;
var libDom;
var updateTagLibFile_Flag = false;
var subFolderName = "ASP.NET/"

function initializeUI()
{
  selectObj = new ListControl("SelectList");
  buildList();
}

function okClicked()
{
  var libNodes;
  var selectionList = buildSelectionList();

  var httpReply = MMHttp.postText(remPath, "mode=introspectSomeSources&sources=" + selectionList);

  if(httpReply.statusCode == 200)
  {
    //----- TEMPORARY SOLUTION ------
	//We will use the new createNewDocument method for this case also....
	var tempFilename = dw.getConfigurationPath() + '/Shared/MM/Cache/empty.htm';
	//-------------------------------

	if (DWfile.exists(tempFilename)) 
	{
	    libFileName = dw.getConfigurationPath() + libPath;
		libDom = dw.getDocumentDOM(libFileName);
		libNodes = libDom.getElementsByTagName("TAGLIBRARY");

		var tempDom = dw.getDocumentDOM(tempFilename);	
		tempDom.documentElement.outerHTML = httpReply.data;
		
		var tagNodes = tempDom.getElementsByTagName("TAG");

		for(var i=0; i<tagNodes.length; i++) {

		  //Check if there's a tag library corresponding to the namespace.	
		  if (!namespaceExists(tagNodes[i].NAMESPACE, libNodes)) {

			//Set the update flag
			updateTagLibFile_Flag = true;

		    //if name space does not exist in the TagLibrary, add a new entry for it. 
			createNewNamespace(tagNodes[i]);
			
			//update the libNodes as the libDom has been updated.
			libNodes = libDom.getElementsByTagName("TAGLIBRARY");
		  } 

		  //update the tag Ref Entry. If it doesn't exist, this function will create it. It will
		  //also update/create the tag reference file as well. 
		  updateTagRefEntry(tagNodes[i]);
		}
	
  		var cNodes = libDom.getElementsByTagName("TAGLIBRARIES");

		if(updateTagLibFile_Flag)
 	      DWfile.write(libFileName, cNodes[0].outerHTML);
	} else {
		alert("Error: Could complete the Import");
	}

  } else {
	alert("Error: HTTP request caused error no: " + httpReply.statusCode);
  }
  window.close();
} 

function cancelClicked() 
{
  window.close();
}

//*************************Local Functions**************************

function buildList()
{
  var httpReply = MMHttp.postText(remPath, "mode=listAllSources");	

  if(httpReply.statusCode == 200)
  {
    var filename = dw.getConfigurationPath() + '/Shared/MM/Cache/empty.htm';
    tagDom = dw.getDocumentDOM(filename);
	tagDom.documentElement.outerHTML = httpReply.data;

    var cNodes = tagDom.getElementsByTagName("ITEMS");
	var cSubNodes = cNodes[0].childNodes;

	for (var i=0; i < cSubNodes.length ; i++)
	{
  	  tagList.push(cSubNodes[i].innerHTML);
	}
  } else {
	alert("Error: HTTP request caused error no: " + httpReply.statusCode);
  }
  selectObj.setAll(tagList, tagList);
}

function buildSelectionList()
{
  var sel = "";

  var selection = new Array();

  var selection = selectObj.getValue("multiple");

  for(var i=0; i<selection.length; i++) {

    sel = sel + selection[i] + ",";   
  }
  return sel;
}

function namespaceExists(nameSpace, libNodes)
{
  var ret = false;
  
  for(var i=0; i<libNodes.length; i++)
  {
    if (libNodes[i].name == nameSpace) {
	  ret = true;
	}
  }
  return ret;
}

function createNewNamespace(tagNode)
{
  var cNodes = libDom.getElementsByTagName("TAGLIBRARIES");
  
  //We know for sure there's only one TAGLIBRARIES element.
  var iHTML = cNodes[0].innerHTML;

  var tagReplacePattern = /@@NAME@@/g;
  var newTagLib = tagLibOpenPattern.replace(tagReplacePattern, tagNode.NAMESPACE);
  newTagLib = newTagLib + "\r\n" + tagLibClosePattern;

  iHTML = iHTML + "\r\n" + newTagLib;
  cNodes[0].innerHTML = iHTML;

}

function updateTagRefEntry(tagNode)
{
  var cNodes = libDom.getElementsByTagName("TAGLIBRARY")
  var cTagRefNodes;
  var nodeIndex = -1;
  var tagRefIndex = -1;
  var tagRefFileName = ""
  var tagRefDom;
  var iHTML;

  for(var i=0; i<cNodes.length; i++)
  {
	if(cNodes[i].NAME == tagNode.NAMESPACE)
	{ 
	  nodeIndex = i;
	  break;
	}
  }

  if(nodeIndex >= 0)
  {
    //Get the Tag Ref objects from the selected TagLibrary. 
    cTagRefNodes = cNodes[nodeIndex].childNodes;

	for(var j=0; j<cTagRefNodes.length; j++) {
      if(cTagRefNodes[j].Name == tagNode.Name) {
	    tagRefIndex = j;
		break;
	  }
	}
    
	if(tagRefIndex >= 0) {
	  
	  //An entry already exists for the tag. Just get the filename....
      
	  tagRefFileName = cTagRefNodes[tagRefIndex].File;

	} else {

	  //This is a new tag. We will need to create an entry.

      iHTML = cNodes[nodeIndex].innerHTML;
      var tagRefNamePattern = /@@NAME@@/g;
	  var newTagRef = tagRefPattern.replace(tagRefNamePattern, tagNode.NAME);
	  tagRefFileName = subFolderName + tagNode.NAME + ".vtm"
	  iHTML = iHTML + newTagRef + "\r\n";
	  cNodes[nodeIndex].innerHTML = iHTML;

	  //Don't forget to set the update flag
	  updateTagLibFile_Flag = true;
	}

  } else {
    //Something bad happened. We got here without a namespace being created. Don't do anything.
    return;
  }

  //OK, Now on to the individual VTM file...

  //Form the url to the tag ref file.
  var fileName = dw.getConfigurationPath() + '/TagLibraries/' + tagRefFileName;

  //If file exists, open it..
  if(DWfile.exists(fileName)) {

    tagRefDom = dw.getDocumentDOM(fileName);

	var tNodes = tagRefDom.getElementsByTagName("TAG");

    if(tNodes.length > 0) {
	  tNodes[0].innerHTML = tagNode.innerHTML;
	}

  } else {
    //We gotta create one 

	/* -- TEMPORARY SOLUTION --
      We don't have a method to create a new document without UD opening it up in the
	  doc view, so we'll wade around the problem by opening an "empty" file and then saving
	  it as the one we want.
	----------------------------*/

	var tempFileName = dw.getConfigurationPath() + '/Shared/MM/Cache/ImportTemp.htm';

    DWfile.copy(tempFileName, fileName);

    tagRefDom = dw.getDocumentDOM(fileName);
  
    var tagPatternStr = /@@NAME@@/g;

	//Note: We may have to do something special with the BIND.
	var tag2PatternStr = /@@BIND@@/g;

    var newTagString = tagPattern.replace(tagPatternStr, tagNode.NAME);
    newTagString = newTagString.replace(tag2PatternStr, "");

	tagRefDom.documentElement.outerHTML = newTagString;

	var tNodes = tagRefDom.getElementsByTagName("TAG");
    
	if(tNodes.length > 0) {
      tNodes[0].innerHTML = tagNode.innerHTML;
	}
  }

  var oHTML = tagRefDom.documentElement.outerHTML;

  //We got all the info we need, so let's write the file...
  
  DWfile.write(fileName, oHTML);

}