// Copyright 2001 Macromedia, Inc. All rights reserved.
/* loc_strings.js
*
* strings.js and loc_strings.js contain arrays for populating select lists 
* in tag dialogs. Both files use the naming convention arrayNameCap for the
* option labels (i.e., text that will be shown to the user) and arrayNameVal
* for the option values(i.e., the code that will be inserted into the document).
* 
* for obvious reasons, loc_strings.js mainly contains the Cap arrays, and
* strings.js mainly contains the Val arrays. only loc_strings.js should be
* localized.  
*
* note: where the labels should not be localized, select lists are intialized
* using the Val array for both the labels and the values.
* 
*/

//--------------- LOCALIZEABLE GLOBALS---------------

var theAlignmentsLRCap = new Array("left", "right");
var theAlignmentsImgCap = new Array("NotSet","Left","Right","Baseline","Top","Middle","Bottom","AbsMiddle","AbsBottom","Texttop");
var theStandardAlignsCap = new Array("NotSet","Left","Center","Right","Justify");
var theStandardFourAlignsCap = new Array("NotSet","Left","Center","Right");
var theStandardValignsCap = new Array("NotSet","Top","Middle","Bottom"); 
var theStandardGridlinesCap = new Array("None", "Horizontal", "Vertical", "Both"); 

var theDirectionsCap = new Array("horizontal", "vertical"); 

var theDisplaysCap = new Array("None","Static","Dynamic"); 
var theDisplayModesVSCap = new Array("List","BulletList","SingleParagraph"); 

var theLayoutsCap = new Array("table", "flow"); 

var theOperatorsCap = new Array("Equal","NotEqual","GreaterThan","GreaterThanEqual","LessThan","LessThanEqual","DataTypeCheck"); 

var theRepeatDirRBLCap = new Array("Horizontal","Vertical"); 
var theRepeatLayRBLCap = new Array("Left", "Right"); 

var theSelectionsLBCap = new Array("single", "multiple"); 
var theStylesCap = new Array("notset", "none", "dotted", "dashed","solid","double","groove","ridge","inset","outset"); 

var	theTextModesCap = new Array("SingleLine", "MultiLine", "Password"); 
var theTypesCap = new Array("String","Integer","Double","Date","Currency");

var theTargetVal = new Array("_top","_parent","_self","_blank"); 
var theRepeatDirectionListCap = new Array("Horizontal","Veritcal"); 
var theRepeatLayoutListCap = new Array("Table","Flow"); 

var theCalendarDayNameFormatCap = new Array("Short","FirstLetter","FirstTwoLetters"); 
var theCalendarNextPrevFormatCap = new Array("Custom Text","Short Month","Full Month"); 
var theCalendarSelectionModeCap = new Array("None","Day","Day Week","Day Week Month"); 
var theCalendarTitleFormatCap = new Array("Month","Month Year"); 
var theCalendarFirstDayOfWeekCap = new Array("Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"); 

var theButtonColumnButtonTypCap = new Array("LinkButton","PushButton"); 

// custom MM tags 
var theParameterDirectionCap = new Array("Input","InputOutput","Output","ReturnValue"); 
var theParameterTypeCap = new Array("BigInt","Boolean","Char","Currency","DBDate","DBTime","DBTimeStamp","Decimal","Double","Integer","Single","SmallInt","TinyInt","UnsignedBigInt","UnsignedInt","UnsignedSmallInt","UnsignedTinyInt","VarChar","VarWChar","VarNumeric"); 

//--------------- END LOCALIZEABLE   ---------------
