// Copyright 2001 Macromedia, Inc. All rights reserved.
/* loc_strings.js
*
* strings.js and loc_strings.js contain arrays for populating select lists 
* in tag dialogs. Both files use the naming convention arrayNameCap for the
* option labels (i.e., text that will be shown to the user) and arrayNameVal
* for the option values(i.e., the code that will be inserted into the document).
* 
* for obvious reasons, loc_strings.js mainly contains the Cap arrays, and
* strings.js mainly contains the Val arrays. only loc_strings.js should be
* localized.  
*
* note: where the labels should not be localized, select lists are intialized
* using the Val array for both the labels and the values.
* 
*/

//--------------- LOCALIZEABLE GLOBALS---------------

var theInputTypesCap = new Array("checkbox", "creditcard", "date", "eurodate", "float", "integer", "password", "phone", "radio", "ssc", "text", "time", "zipcode"); 

var theJRunFormMethodsCap = new Array("get", "post"); 

var theSelJNDICap = new Array("lookup", "list", "attribute", "search"); 
var theSelmailparamCap = new Array("Attachments", "Headers"); 
var theSelSelectCap = new Array("hashtable","columns");
var theSelSQLCap = new Array("JDBC Connection", "J2EE Data Source", "JDBC Driver"); 
var theSelXSLTCap = new Array("input","empty");
var theMailTypesCap = new Array("Mail Server","JavaMail");
var theSQLTypesCap = new Array("ARRAY","BIGINT","BINARY","BIT","BLOB","CHAR","CLOB","DATE","DECIMAL","DISTINCT","DOUBLE",
                         "FLOAT","INTEGER","JAVA_OBJECT","LONGVARBINARY","NULL","NUMERIC","OTHER","REAL","REF","SMALLINT","STRUCT",
                         "TIME","TIMESTAMP","TINYINT","VARBINARY","VARCHAR"); 

//--------------- END LOCALIZEABLE   ---------------