// Copyright 2000,2001 Macromedia, Inc. All rights reserved.

//*************** GLOBALS  *****************

var USE_SITE_RELATIVE = false;


//******************* LOCAL FUNCTIONS **********************

function isDOMRequired() {
  // Return false, indicating that this object is available in code view.
  // This will prevent the document from syncing with design view on every
  // paste in code view.  This command actually does require that the DOM
  // be synchronized, but we'll postpone that until we're sure that we're
  // actually pasting Fireworks HTML.
  return false;
}

function initialize() {
var validFWFile = false;
var fwSource = dw.getClipboardText();
  if (fwSource && isFireworksHTML(fwSource)) {
    validFWFile = true;
      MM.event.handled = pasteFWHTML();
  }else{
    MM.event.handled = false;
  }
}


function pasteFWHTML() {
  var result, validFWFile=false;
  var fwURL, fwSource, fwDOM;
  var docURL, docDOM, siteURL, parentFile, docRootURL, siteRootURL;

  // Force a sync... we have postponed this until we are certain that we're
  // actually pasting Fireworks HTML.
  if (!dw.getDocumentDOM().isDesignViewUpdated())
	  dw.getDocumentDOM().synchronizeDocument();

  fwSource = dw.getClipboardText();

  if (fwSource && isFireworksHTML(fwSource)) {
    validFWFile = true;
    if (!isDWStyle(fwSource))
      alert(MSG_notExportedForDW);
    else if (!usesDWBehaviors(fwSource))
      alert(MSG_behNotSupported);
  }

  if (validFWFile) {
    fwURL = dw.getConfigurationPath() + "/Shared/MM/Cache/empty.htm";
    DWfile.write(fwURL,'');
    fwDOM = dw.getDocumentDOM(fwURL);
    
    //for i18n, we need to make sure the fwDOM matches the encoding of the users dom
  	fwDOM.setCharSet( dw.getDocumentDOM('document').getCharSet() );
  
    fwDOM.body.innerHTML = fwSource;
    docURL = dw.getDocumentPath("document");
    siteURL = dw.getSiteRoot();

    docRootURL = '';
    siteRootURL = '';
    if (docURL) {
      parentFile = new File(docURL);
      docRootURL = parentFile.getAbsoluteParent() + File.separator;
      if (USE_SITE_RELATIVE) {
        parentFile = new File(siteURL);
        siteRootURL = parentFile.getAbsolutePath();
      }
    }

    theHTML = insertFireworksHTML(fwDOM, fwURL, docRootURL, siteRootURL);
  
  dw.releaseDocument(fwDOM);

    docDOM = dw.getDocumentDOM('document');
    docDOM.insertHTML(theHTML);
  }

  return validFWFile;
}
