// Copyright 2001 Macromedia, Inc. All rights reserved.
// Specifies tag to use when applying font changes.
// Return either "font" or "span".
function getFontTag(){
	return "span";
}

// Specifes units when font changes are applied with SPAN tags 
// (ignored if getFontTag() returns "font"). Return either
// "pixels" or "points".
function getFontUnits(){
	return "pixels";
}

// Defines list of default fonts. Enclose multiple-word font names in single quotes.
function getFontList(){
	var fontList = new Array()
	fontList[0] = "Arial, Helvetica, sans-serif";
	fontList[1] = "'Times New Roman', Times, serif";
	fontList[2] = "'Courier New', Courier, mono";
	fontList[3] = "Georgia, 'Times New Roman', Times, serif";
	fontList[4] = "Geneva, Arial, Helvetica, sans-serif";
	fontList[5] = "Verdana, Tahoma, Geneva, sans-serif";
	
	return fontList;
}

// Specifies whether to show the Font and Size menus
// in the toolbar. Return either true or false (no quotation marks).
function getShowFontsAndSizes(){
	return true;
}


// NOTE: If both of the following functions return false, then
// the Style pop-up menu will not appear in the toolbar. In addition,
// if getShowHeadings() is false and there are no styles defined for
// the document, the pop-up menu will also not appear. It will reappear
// if a document containing styles is opened.

// Specifies whether to show H1, H2, P, etc. in Styles list. 
// Return either true or false (no quotation marks).
function getShowHeadings(){
	return true;
}

// Specifies whether to show CSS Styles in Styles list. 
// Return either true or false (no quotation marks).
function getShowStyles(){
	return true;
}

